"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _compose = _interopRequireDefault(require("recompose/compose"));

var _reactRouterDom = require("react-router-dom");

var _raCore = require("ra-core");

var _reactAdmin = require("react-admin");

var _ViewList = _interopRequireDefault(require("@material-ui/icons/ViewList"));

var _ChevronRight = _interopRequireDefault(require("@material-ui/icons/ChevronRight"));

var _SubMenu = _interopRequireDefault(require("./SubMenu"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _instanceof(left, right) { if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) { return right[Symbol.hasInstance](left); } else { return left instanceof right; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!_instanceof(instance, Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Menu =
/*#__PURE__*/
function (_Component) {
  _inherits(Menu, _Component);

  function Menu() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Menu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Menu)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {});

    return _this;
  }

  _createClass(Menu, [{
    key: "handleToggle",
    value: function handleToggle(menu) {
      this.setState(function (state) {
        return _defineProperty({}, "menu_".concat(menu), !state["menu_".concat(menu)]);
      });
    }
  }, {
    key: "generateStructure",
    value: function generateStructure() {
      var resources = this.props.resources;
      var structure = [],
          i = -1;
      resources.forEach(function (res) {
        if (res.name.indexOf('_') > 0) {
          structure[i] = structure[i] && structure[i][0] ? [].concat(_toConsumableArray(structure[i]), [res]) : [structure[i], res];
          structure[i].first = structure[i].first || structure[i][0];
        } else {
          structure[++i] = res;
        }
      });
      return structure;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          onMenuClick = _this$props.onMenuClick,
          open = _this$props.open,
          logout = _this$props.logout;
      var structure = this.generateStructure();
      return _react.default.createElement("div", null, ' ', _react.default.createElement(_reactAdmin.DashboardMenuItem, {
        onClick: onMenuClick
      }), structure.map(function (item, index) {
        return item && item.first ? _react.default.createElement(_SubMenu.default, {
          key: index,
          handleToggle: function handleToggle() {
            return _this2.handleToggle(item[0].name);
          },
          isOpen: _this2.state["menu_".concat(item[0].name)],
          sidebarIsOpen: open,
          name: source2Label(item[0].name),
          icon: item.first.icon ? _react.default.createElement(item.first.icon, null) : _react.default.createElement(_ChevronRight.default, null)
        }, item.map(function (item) {
          return _react.default.createElement(_reactAdmin.MenuItemLink, {
            key: item.name,
            to: "/".concat(item.name),
            primaryText: source2Label(item.name),
            onClick: onMenuClick,
            leftIcon: item.icon ? _react.default.createElement(item.icon, null) : _react.default.createElement(_ViewList.default, null)
          });
        })) : _react.default.createElement(_reactAdmin.MenuItemLink, {
          key: item.name,
          to: "/".concat(item.name),
          primaryText: source2Label(item.name),
          onClick: onMenuClick,
          leftIcon: item.icon ? _react.default.createElement(item.icon, null) : _react.default.createElement(_ViewList.default, null)
        });
      }), _react.default.createElement(_reactAdmin.Responsive, {
        small: logout,
        medium: null
      }));
    }
  }]);

  return Menu;
}(_react.Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    open: state.admin.ui.sidebarOpen,
    locale: state.i18n.locale,
    resources: (0, _raCore.getResources)(state)
  };
};

var enhance = (0, _compose.default)(_reactRouterDom.withRouter, (0, _reactRedux.connect)(mapStateToProps, {}), _reactAdmin.translate);

var source2Label = function source2Label(source) {
  return source && source[0].toUpperCase() + source.substring(1).split(/[_\-.]/).join(' ');
};

var _default = enhance(Menu);

exports.CustomMenu = Menu;

exports.default = _default;