"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _ExpandMore = _interopRequireDefault(require("@material-ui/icons/ExpandMore"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemIcon = _interopRequireDefault(require("@material-ui/core/ListItemIcon"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _Collapse = _interopRequireDefault(require("@material-ui/core/Collapse"));

var _styles = require("@material-ui/core/styles");

var _reactAdmin = require("react-admin");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var styles = {
  listItem: {
    paddingLeft: '1rem'
  },
  listItemText: {
    paddingLeft: 2,
    fontSize: '1rem'
  },
  sidebarIsOpen: {
    paddingLeft: 25,
    transition: 'padding-left 195ms cubic-bezier(0.4, 0, 0.6, 1) 0ms'
  },
  sidebarIsClosed: {
    paddingLeft: 0,
    transition: 'padding-left 195ms cubic-bezier(0.4, 0, 0.6, 1) 0ms'
  }
};

var SubMenu = function SubMenu(_ref) {
  var handleToggle = _ref.handleToggle,
      sidebarIsOpen = _ref.sidebarIsOpen,
      isOpen = _ref.isOpen,
      name = _ref.name,
      icon = _ref.icon,
      classes = _ref.classes,
      children = _ref.children,
      translate = _ref.translate;
  return _react.default.createElement(_react.Fragment, null, _react.default.createElement(_ListItem.default, {
    dense: true,
    button: true,
    onClick: handleToggle,
    className: classes.listItem
  }, _react.default.createElement(_ListItemIcon.default, null, isOpen ? _react.default.createElement(_ExpandMore.default, null) : icon), _react.default.createElement(_ListItemText.default, {
    inset: true,
    primary: isOpen ? translate(name) : '',
    secondary: isOpen ? '' : translate(name),
    className: classes.listItemText
  })), _react.default.createElement(_Collapse.default, {
    in: isOpen,
    timeout: "auto",
    unmountOnExit: true
  }, _react.default.createElement(_List.default, {
    dense: true,
    component: "div",
    disablePadding: true,
    className: sidebarIsOpen ? classes.sidebarIsOpen : classes.sidebarIsClosed
  }, children), _react.default.createElement(_Divider.default, null)));
};

var enhance = (0, _compose.default)((0, _styles.withStyles)(styles), _reactAdmin.translate);

var _default = enhance(SubMenu);

exports.default = _default;