import { connect } from 'react-redux';
import compose from 'recompose/compose';
import { withRouter } from 'react-router-dom';
import { getResources } from 'ra-core';
import { translate } from 'react-admin';
import { CustomTreeMenu, ResFinder } from 'ra-tree-menu';

class MyTreeMenu extends CustomTreeMenu {
    generateStructure() {        
        const { resources } = this.props;
        const resByName = ResFinder(resources);

        var structure = [
            resByName('users'),
            resByName('lorem'),
            [
                resByName('ipsum'),
                resByName('dolor')
            ],
            resByName('sit')
        ];

        return structure;
    }
}

const mapStateToProps = state => ({
    open: state.admin.ui.sidebarOpen,
    locale: state.i18n.locale,
    resources: getResources(state),
});

const enhance = compose(
    withRouter,
    connect(
        mapStateToProps,
        {}
    ),
    translate
);

const source2Label = source => source && (
    source[0].toUpperCase() + source.substring(1).split(/[_\-.]/).join(' ')
);

export const CustomMenu = Menu;

export default enhance(Menu);